/*
 * Intel ACPI Component Architecture
 * AML/ASL+ Disassembler version 20141107-64 [Dec 17 2014]
 * Copyright (c) 2000 - 2014 Intel Corporation
 * 
 * Disassembling to symbolic ASL+ operators
 *
 * Disassembly of ssdt9.dat, Sun Oct  4 08:14:39 2015
 *
 * Original Table Header:
 *     Signature        "SSDT"
 *     Length           0x00000FB4 (4020)
 *     Revision         0x01
 *     Checksum         0x41
 *     OEM ID           "LENOVO"
 *     OEM Table ID     "CB-01   "
 *     OEM Revision     0x00000001 (1)
 *     Compiler ID      "INTL"
 *     Compiler Version 0x20110316 (537985814)
 */
DefinitionBlock ("ssdt9.aml", "SSDT", 1, "LENOVO", "CB-01   ", 0x00000001)
{
    /*
     * iASL Warning: There were 14 external control methods found during
     * disassembly, but additional ACPI tables to resolve these externals
     * were not specified. This resulting disassembler output file may not
     * compile because the disassembler did not know how many arguments
     * to assign to these methods. To specify the tables needed to resolve
     * external control method references, the -e option can be used to
     * specify the filenames. Example iASL invocations:
     *     iasl -e ssdt1.aml ssdt2.aml ssdt3.aml -d dsdt.aml
     *     iasl -e dsdt.aml ssdt2.aml -d ssdt1.aml
     *     iasl -e ssdt*.aml -d dsdt.aml
     *
     * In addition, the -fe option can be used to specify a file containing
     * control method external declarations with the associated method
     * argument counts. Each line of the file must be of the form:
     *     External (<method pathname>, MethodObj, <argument count>)
     * Invocation:
     *     iasl -fe refs.txt -d dsdt.aml
     *
     * The following methods were unresolved and many not compile properly
     * because the disassembler had to guess at the number of arguments
     * required for each:
     */
    External (M000, MethodObj)    // Warning: Unresolved method, guessing 1 arguments
    External (M013, MethodObj)    // Warning: Unresolved method, guessing 4 arguments
    External (M014, MethodObj)    // Warning: Unresolved method, guessing 7 arguments
    External (M017, MethodObj)    // Warning: Unresolved method, guessing 6 arguments
    External (M018, MethodObj)    // Warning: Unresolved method, guessing 7 arguments
    External (M019, MethodObj)    // Warning: Unresolved method, guessing 4 arguments
    External (M029, MethodObj)    // Warning: Unresolved method, guessing 3 arguments
    External (M031, MethodObj)    // Warning: Unresolved method, guessing 3 arguments
    External (M032, MethodObj)    // Warning: Unresolved method, guessing 7 arguments
    External (M044, MethodObj)    // Warning: Unresolved method, guessing 1 arguments
    External (M045, MethodObj)    // Warning: Unresolved method, guessing 1 arguments
    External (M049, MethodObj)    // Warning: Unresolved method, guessing 3 arguments
    External (M111, MethodObj)    // Warning: Unresolved method, guessing 4 arguments
    External (M134, MethodObj)    // Warning: Unresolved method, guessing 2 arguments

    External (_ADR, IntObj)
    External (_SB_.PCI0.SATA, DeviceObj)
    External (M128, UnknownObj)

    Scope (\_SB.PCI0.SATA)
    {
        Name (M048, One)
        Method (_DSM, 4, Serialized)  // _DSM: Device-Specific Method
        {
            If ((XCMP (Arg0, ToUUID ("e4db149b-fcfe-425b-a6d8-92357d78fc7f") /* SATA Controller */) == One))
            {
                If ((Arg2 == Zero))
                {
                    Return (Buffer (One)
                    {
                         0x03                                             /* . */
                    })
                }
                Else
                {
                    If ((Arg2 == One))
                    {
                        Name (ADDR, Package (0x01)
                        {
                            0x0001FFFF
                        })
                        Return (One) = Else
                                {
                                    If ((Arg2 == 0x02))
                                    {
                                        Local0 = DerefOf (Index (Arg3, Zero))
                                        If (((Local0 == (If ((Local1 == Zero))
                                                        {
                                                            STPT (Zero)
                                                            Return (Zero)
                                                        } = (((Local0 == Ones) = (M049 (M134 (0x15, 0x00010000), Zero, 0xFFFF) * 
                                                                Zero)) + Local1 = DerefOf (Index (Arg3, One))))) || Else
                                                {
                                                    If ((Local1 == One))
                                                    {
                                                        If (M045 (\_SB.PCI0.SATA.ODD8._PS0 ())) {}
                                                        Else
                                                        {
                                                            If (M044 (\_SB.PCI0.SATA.ODDL._PS0 ())) {}
                                                            Else
                                                            {
                                                                \_SB.PCI0.SATA.ODDZ._PS0 ()
                                                            }
                                                        }

                                                        Return (Zero)
                                                    }
                                                })) {}
                                    }
                                } = ((Index (ADDR, Zero) = (M049 (M134 (0x15, 0x00010000), Zero, 
                                                            0xFFFF) * Zero)) + Return (Package (0x01)
                                {
                                    ADDR
                                }))
                    }
                }
            }
        }

        Method (XCMP, 2, NotSerialized)
        {
            If ((0x10 != SizeOf (Arg0)))
            {
                Return (Zero)
            }

            If ((0x10 != SizeOf (Arg1)))
            {
                Return (Zero)
            }

            Local0 = Zero
            While ((Local0 < 0x10))
            {
                If ((DerefOf (Index (Arg0, Local0)) != DerefOf (Index (Arg1, Local0
                    ))))
                {
                    Return (Zero)
                }

                Local0++
            }

            Return (One)
        }

        Method (STDV, 0, Serialized)
        {
            Local0 = _ADR /* External reference */
            Return ((Local0 >> 0x10))
        }

        Method (STFN, 0, Serialized)
        {
            Local0 = _ADR /* External reference */
            Return ((Local0 & 0xFFFF))
        }

        Method (PBAA, 0, Serialized)
        {
            Local0 = M019 (Zero, STDV (), STFN (), 0x24)
            If ((Local0 == Ones))
            {
                Local0 = Zero
            }

            Return (Local0)
        }

        Method (STPT, 1, Serialized)
        {
            M018 (Zero, STDV (), STFN (), 0x42, M049 (M134 (0x15, One), (Arg0 ^ One
                )))
        }

        Method (STPP, 1, Serialized)
        {
            M018 (Zero, STDV (), STFN (), 0x42, M049 (M134 (0x15, One), (Arg0 ^ One
                ), If ((M017 (Zero, STDV (), STFN (), 0x0A, Zero, 0x10) == 0x0106))
                    {
                        If ((PBAA () != Zero))
                        {
                            M018 (Zero, STDV (), STFN (), 0x40, Zero, One, One)
                            M014 (PBAA (), 0x0C, M049 (M134 (0x15, One), Arg0, Local0 = M017 (Zero, 
                                STDV (), STFN (), 0x42, Zero, 0x06)), If ((Local0 == 0x3F))
                                {
                                    M014 (PBAA (), 0x0C, Zero, One, One, Else
                                        {
                                          